#include "Cli.h"
#include "Common.h"
#include "Monitor.h"
#include "Keyboard.h"
#include "Timer.h"

/* Initializes the command line interface */
void cli()
{
    char *cmd;

    do
    {
        monitor_write("SOS:- $ ");

	cmd = keyboard_read();
        if(strcmp(cmd, "logtime") == 0)
	    logtime();

	else if(strcmp(cmd, "help") == 0)
	    help();

	else if(strcmp(cmd, "about") == 0)
	    about();

	else if(strcmp(cmd, "clear") == 0)
	    monitor_clear();

	else if(strcmp(cmd, "exit") == 0)
	    monitor_write("Bye! :D");

	else
	{
	    monitor_write(cmd);	
	    monitor_write(": Command not found.\n\n");
	}
    }while(strcmp(cmd, "exit") != 0);

    for(;;);
}

/* Displays the time logged in by the user, in seconds */
void logtime()
{
    monitor_write("Logtime: ");
    monitor_write_dec(show_seconds());
    monitor_write(" seconds.\n\n");
}

/* Displays help, with a list of available commands */
void help()
{
    about();
    monitor_write("About - Shows about the operating system, SOS.\n");
    monitor_write("Clear - Clears the screen.\n");
    monitor_write("Exit - Exits from the CLI, and halts the system.\n");
    monitor_write("Help - Shows this message.\n");
    monitor_write("Logtime - Shows the time since the system has been logged in.\n\n");
}

/* Displays about the Operating System and its creator -- ME */
void about()
{
    monitor_write("SOS, Shikhin's Operating System.\n");
    monitor_write("Written academic purposes. No licenses applied.\n\n");
}

