#ifndef IDT_H
#define IDT_H

#include "Common.h"

/* Defines an IDT entry */
struct idt_entry
{
    unsigned short base_lo;
    unsigned short sel;        /* Our kernel segment goes here! */
    unsigned char always0;     /* This will ALWAYS be set to 0! */
    unsigned char flags;       /* Set using the above table! */
    unsigned short base_hi;
} __attribute__((packed));

struct idt_ptr
{
    unsigned short limit;
    u32int base;
} __attribute__((packed));

/* Declare an IDT of 256 entries. */
struct idt_entry idt[256];
struct idt_ptr idtp;

/* This exists in LIdt.s, and is used to load our IDT */
extern void idt_load();

/* Installs the IDT */
void idt_install();

/* This function sets an entry in the IDT. */
void idt_set_gate(unsigned char num, unsigned long base, unsigned short sel, unsigned char flags);

#endif
