// monitor.h -- Defines the interface for monitor.h
//              From JamesM's kernel development tutorials.

#ifndef MONITOR_H
#define MONITOR_H

#include "Common.h"

u16int *videomem;	// To store VGA memory buffer.
u8int attributeByte;
u16int attribute;	// To store the attribute
u8int cursor_y; u8int cursor_x;	// To store cursor positions.

// Initialize monitor using the given details.
void monitor_init(int backcolor, int forecolor);

// Change the attribute settings.
void monitor_attrib(int backcolor, int forecolor);

// Write a single character out to the screen.
void monitor_put(char c);

// Clear the screen to all black.
void monitor_clear();

// Output a null-terminated ASCII string to the monitor.
void monitor_write(char *c);

// Output a null-terminated ASCII string to the monitor, with special attributes, applied on the whole line.
void monitor_write_on_line(char *c, int line, int backcolor, int forecolor);

// Write a integer as hexadecimal to the screen.
void monitor_write_hex(u32int n);

// Write a integer as decimal to the screen.
void monitor_write_dec(u32int n);

// Clears the screen, by copying lots of spaces to the framebuffer.
void monitor_clear();

#endif // MONITOR_H
