#ifndef TIMER_H
#define TIMER_h

#include "Common.h"

/* This will keep track of what the hz has been set too. */
int speed;

/* Handles the timer. In this case, it's very simple: We
*  increment the 'timer_ticks' variable every time the
*  timer fires. By default, the timer fires 18.222 times
*  per second. Why 18.222Hz? Some engineer at IBM must've
*  been smoking something funky */
void timer_handler(struct regs *r);

/* Sets up the system clock by installing the timer handler
*  into IRQ0 */
void timer_install();

/* This will cause the system to wait untill the given ticks has
*  been reached */
void timer_wait(int ticks);

/* This will show, how many seconds have passed, since the timer
*  has been initialized */
int show_seconds();

#endif
